%parpool('local',16);
seed=1;
RandStream.setGlobalStream(RandStream('mt19937ar','seed',seed));
R=20000;
n=2000;

meantreatment=0.5;
meandomain=10;
stddomain=5;
blockrand=1;
meanstrata=0.5; %prob of being in strata 1
pz1=0.5;  %success prob of strata 1
pz0=0.5;  %success prob of strata 0
alpha=0.05;
betahats1=zeros(R,1);
betahats2=zeros(R,1);
betahats3=zeros(R,1);
betahats4=zeros(R,1);
standarderrors1=zeros(R,1);
standarderrors2=zeros(R,1);
standarderrors3=zeros(R,1);
standarderrors1boot=zeros(R,1);
standarderrors2boot=zeros(R,1);
standarderrors3boot=zeros(R,1);
standarderrors4boot=zeros(R,1);
standarderrors3naive=zeros(R,1);
cislower1=zeros(R,1);
cisupper1=zeros(R,1);
cislower2=zeros(R,1);
cisupper2=zeros(R,1);
cislower3=zeros(R,1);
cisupper3=zeros(R,1);
cislower1boot=zeros(R,1);
cisupper1boot=zeros(R,1);
cislower2boot=zeros(R,1);
cisupper2boot=zeros(R,1);
cislower3boot=zeros(R,1);
cisupper3boot=zeros(R,1);
cislower4boot=zeros(R,1);
cisupper4boot=zeros(R,1);
cislower3naive=zeros(R,1);
cisupper3naive=zeros(R,1);
gamma0=[1;10];
beta0=[1;0.5;-1;-1];
for r=1:R
domaincharacteristics=normrnd(meandomain,stddomain,n,1);
stratum=domaincharacteristics>meandomain;
strata1=find(stratum==1);
nstrata1=length(strata1);
strata0=find(stratum==0);
nstrata0=length(strata0);
instrument=zeros(n,1);
if(blockrand==1)
    strata1treated=randsample(strata1,ceil(pz1*nstrata1));
    strata0treated=randsample(strata0,ceil(pz0*nstrata0));
    instrument(strata1treated)=1;
    instrument(strata0treated)=1;
else
    instrument(strata1)=binornd(1,pz1,nstrata1,1);
    instrument(strata0)=binornd(1,pz0,nstrata0,1);
end
data=mvnrnd(ones(n,1)*[0,0],[2 0.5;0.5 2]);
nu=data(:,1);
epsilon=data(:,2);
treatment=(gamma0(1)+gamma0(2)*instrument+nu>0);

winningbid=beta0(1)+beta0(2)*treatment+beta0(3)*treatment.*domaincharacteristics.^2+beta0(4)*domaincharacteristics+epsilon;
stratumdomain=stratum.*domaincharacteristics;
meandomainlength=mean(domaincharacteristics);
interaction=instrument.*(stratum-mean(stratum));
interaction2=instrument.*(domaincharacteristics-meandomainlength);

meanstratumdomain=mean(stratumdomain);
interaction3=instrument.*(stratumdomain-meanstratumdomain);
Z4=[ones(n,1) instrument stratum domaincharacteristics stratumdomain interaction interaction2 interaction3];
Pz4=Z4/(Z4'*Z4)*Z4';
X=[ones(n,1) treatment stratum domaincharacteristics stratumdomain interaction interaction2 interaction3];
beta4=pinv(X'*Pz4*X)*(X'*Pz4*winningbid);
betahats4(r)=beta4(2);

W3=[ones(n,1) treatment stratum interaction];
Z3=[ones(n,1) instrument stratum interaction];
Pz3=Z3/(Z3'*Z3)*Z3';
beta=pinv(W3'*Pz3*W3)*(W3'*Pz3*winningbid);
betahats3(r)=beta(2);
p=mean(instrument);
e=winningbid-W3*beta;
ebar=(instrument-p).*e+p*(1-p)*beta(4)*(stratum-mean(stratum));

covzd=mean(treatment.*instrument)-p.*mean(treatment);
sigmabar2=mean(ebar.^2)/(covzd^2);
sigmabar=sqrt(sigmabar2)/sqrt(n);

standarderrors3(r)=sigmabar;

cislower3(r)=beta(2)-1.96*sigmabar;
cisupper3(r)=beta(2)+1.96*sigmabar;

W2=[ones(n,1) treatment stratum];
Z2=[ones(n,1) instrument stratum];
Pz2=Z2/(Z2'*Z2)*Z2';

beta2=pinv(W2'*Pz2*W2)*(W2'*Pz2*winningbid);
betahats2(r)=beta2(2);
A2=W2'*Pz2*W2;
e2=winningbid-W2*beta2;

B2=W2'*Pz2*diag(e2.^2)*Pz2*W2;
V2=pinv(A2)*B2*pinv(A2);
s2=sqrt(V2(2,2));
standarderrors2(r)=s2;
cislower2(r)=beta2(2)-1.96*s2;
cisupper2(r)=beta2(2)+1.96*s2;

Z1=[ones(n,1) instrument];
Pz=Z1/(Z1'*Z1)*Z1';
W1=[ones(n,1) treatment];
beta1=pinv(W1'*Pz*W1)*(W1'*Pz*winningbid);
betahats1(r)=beta1(2);
A1=W1'*Pz*W1;
e1=winningbid-W1*beta1;
B1=W1'*Pz*diag(e1.^2)*Pz*W1;
V1=pinv(A1)*B1*pinv(A1);
s1=sqrt(V1(2,2));
standarderrors1(r)=s1;
cislower1(r)=beta1(2)-1.96*s1;
cisupper1(r)=beta1(2)+1.96*s1;


end
meanlength1=nanmean(cisupper1-cislower1)
meanlength2=nanmean(cisupper2-cislower2)
meanlength3=nanmean(cisupper3-cislower3)
meanstd1=nanmean(standarderrors1)
meanstd2=nanmean(standarderrors2)
meanstd3=nanmean(standarderrors3)

montecarlostd1=std(betahats1)
montecarlostd2=std(betahats2)
montecarlostd3=std(betahats3)

save(sprintf('montecarlocovariateadaptiveLATE_n%i_R%i_blockrand%i_pz1%1.2g_pz0%1.2g.mat',[n,R,blockrand,pz1,pz0]),...
    'beta0','gamma0','pz1','pz0','n','R','meanlength1','meanlength2','meanlength3',...
    'meanstd1','meanstd2','meanstd3',...
    'montecarlostd1','montecarlostd2','montecarlostd3',...
    'betahats1','betahats2','betahats3');
