%parpool('local',16);
seed=1;
RandStream.setGlobalStream(RandStream('mt19937ar','seed',seed));
R=20000;
n=2000;

meantreatment=0.5;
meandomain=10;
stddomain=5;
blockrand=1;
meanstrata=0.5; %prob of being in strata 1
pz1=0.5;  %success prob of strata 1
pz0=0.5;  %success prob of strata 0
alpha=0.05;
betahats1=zeros(R,1);
betahats2=zeros(R,1);
betahats3=zeros(R,1);

standarderrors1=zeros(R,1);
standarderrors2=zeros(R,1);
standarderrors3=zeros(R,1);

cislower1=zeros(R,1);
cisupper1=zeros(R,1);
cislower2=zeros(R,1);
cisupper2=zeros(R,1);
cislower3=zeros(R,1);
cisupper3=zeros(R,1);
beta0=[1;0.5;-1;-1];

for r=1:R
domaincharacteristics=normrnd(meandomain,stddomain,n,1);
stratum=domaincharacteristics>meandomain;
strata1=find(stratum==1);
nstrata1=length(strata1);
strata0=find(stratum==0);
nstrata0=length(strata0);
treatment=zeros(n,1);
if(blockrand==1)
    strata1treated=randsample(strata1,ceil(pz1*nstrata1));
    strata0treated=randsample(strata0,ceil(pz0*nstrata0));
    treatment(strata1treated)=1;
    treatment(strata0treated)=1;
else
    treatment(strata1)=binornd(1,pz1,nstrata1,1);
    treatment(strata0)=binornd(1,pz0,nstrata0,1);
end
epsilon=normrnd(0,1,n,1);
winningbid=beta0(1)+beta0(2)*treatment+beta0(3)*treatment.*domaincharacteristics.^2+beta0(4)*domaincharacteristics+epsilon;
interaction=treatment.*(stratum-mean(stratum));
X=[ones(n,1) treatment stratum interaction];
beta=X\winningbid; 
betahats3(r)=beta(2);
p=mean(treatment);
e=winningbid-X*beta;
ebar=(treatment-p).*e+p*(1-p)*beta(4)*(stratum-mean(stratum));

varz=mean(treatment.^2)-p^2;
sigmabar2=mean(ebar.^2)/(varz^2);
sigmabar=sqrt(sigmabar2)/sqrt(n);
standarderrors3(r)=sigmabar;

cislower3(r)=beta(2)-1.96*sigmabar;
cisupper3(r)=beta(2)+1.96*sigmabar;

W2=[ones(n,1) treatment stratum];

beta2=W2\winningbid;
betahats2(r)=beta2(2);
A2=W2'*W2;
e2=winningbid-W2*beta2;
B2=W2'*diag(e2.^2)*W2;
V2=A2\B2/A2;
s2=sqrt(V2(2,2));
standarderrors2(r)=s2;
cislower2(r)=beta2(2)-1.96*s2;
cisupper2(r)=beta2(2)+1.96*s2;

W1=[ones(n,1) treatment];
beta1=W1\winningbid;
betahats1(r)=beta1(2);
A1=W1'*W1;
e1=winningbid-W1*beta1;
B1=W1'*diag(e1.^2)*W1;
V1=A1\B1/A1;
s1=sqrt(V1(2,2));
standarderrors1(r)=s1;
cislower1(r)=beta1(2)-1.96*s1;
cisupper1(r)=beta1(2)+1.96*s1;


end

meanlength1=nanmean(cisupper1-cislower1)
meanlength2=nanmean(cisupper2-cislower2)
meanlength3=nanmean(cisupper3-cislower3)
meanstd1=nanmean(standarderrors1)
meanstd2=nanmean(standarderrors2)
meanstd3=nanmean(standarderrors3)

montecarlostd1=std(betahats1)
montecarlostd2=std(betahats2)
montecarlostd3=std(betahats3)
save(sprintf('montecarlocovariateadaptive_n%i_R%i_blockrand%i_pz1%1.2g_pz0%1.2g.mat',[n,R,blockrand,pz1,pz0]),...
    'pz1','pz0','beta0','R','n','meanlength1','meanlength2','meanlength3',...
    'meanstd1','meanstd2','meanstd3',...
    'montecarlostd1','montecarlostd2','montecarlostd3',...
    'betahats1','betahats2','betahats3');
